<template>
    <q-item
      dense v-if="!subItems.length"
      clickable tag="a" :target="target"
      :to="link" :active="isActive(link)"
    >
      <q-item-section avatar>
        <q-icon :name="icon" size="md"/>
      </q-item-section>

      <q-item-section>
        <q-item-label>{{ title }}</q-item-label>
        <q-item-label v-if="subTitle" caption>
          {{ subTitle }}
        </q-item-label>
      </q-item-section>
    </q-item>
    <menu-sub-item
      v-else
      :is-leaf-active="isLeafActive"
      :icon="icon" v-model="leaf"
      :title="title" :sub-title="subTitle"
      :items="subItems">
      <template v-slot="items">
        <menu-item
          v-if="item.visible" v-for="(item, index) in items"
          :key="index" :sub-menu="item.subItems"
          v-bind="item"
        />
      </template>
    </menu-sub-item>
</template>

<script>
import MenuSubItem from "components/Menu/MenuSubItem";
import get from 'lodash/get'

export default {
  name: "MenuItem",
  components: {MenuSubItem},
  props: {
    icon: String,
    link: [String, Object],
    title: String,
    subTitle: String,
    target: String,
    visible: Boolean,
    subItems: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      leaf: false
    }
  },
  created() {
    this.leaf = this.isLeafActive;
  },
  computed: {
    isLeafActive() {
      return this.subItems.some(({link}) =>
        (typeof link === 'object' ? link.name === this.$route.name : this.isActive(link)));
    },

  },
  methods: {
    isActive(link) {
      return this.$route.path.indexOf(link) >= 0
    },
    // hasMenu(item) {
    //   let userPermissions = get(this.$store.state.authentication, 'user.permissions')
    //   if (item.permissions && item.permissions.length > 0) {
    //     return item.permissions.some(x => {
    //       return (userPermissions || []).includes(x)
    //     })
    //   } else {
    //     return true
    //   }
    // },
  },
  mounted() {}
}
</script>

<style scoped>

</style>
